%define		realname	libpng
Summary:	PNG library - MinGW32 cross version
Summary(pl.UTF-8):	Biblioteka PNG - wersja skrośna dla MinGW32
Name:		crossmingw32-%{realname}
Version:	1.6.46
Release:	1
License:	distributable
Group:		Development/Libraries
Source0:	https://downloads.sourceforge.net/libpng/%{realname}-%{version}.tar.xz
# Source0-md5:	2ba00adb5d5c76d512486559a3e77be7
Patch0:		https://downloads.sourceforge.net/libpng-apng/%{realname}-%{version}-apng.patch.gz
# Patch0-md5:	30b2da9a1e27235499806e415bc56840
Patch1:		%{realname}-pngminus.patch
URL:		http://www.libpng.org/pub/png/libpng.html
BuildRequires:	crossmingw32-gcc
BuildRequires:	crossmingw32-zlib
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz >= 1:4.999.7
Requires:	crossmingw32-zlib >= 1.2.9
Provides:	crossmingw32-libpng(APNG) = 0.10
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1
%define		_enable_debug_packages	0

%define		target			i386-mingw32
%define		target_platform		i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
%define		optflags	-O2
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld    -Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*

%description
The PNG library is a collection of routines used to create and
manipulate PNG format graphics files. The PNG format was designed as a
replacement for GIF, with many improvements and extensions.

This package contains the cross version for Win32.

%description -l pl.UTF-8
Biblioteki PNG są kolekcją form używanych do tworzenia i manipulowania
plikami w formacie graficznym PNG. Format ten został stworzony jako
zamiennik dla formatu GIF, z wieloma rozszerzeniami i nowościami.

Ten pakiet zawiera wersję skrośną dla Win32.

%package static
Summary:	Static libpng library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka libpng (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Provides:	crossmingw32-libpng-static(APNG) = 0.10

%description static
Static libpng library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka libpng (wersja skrośna MinGW32).

%package dll
Summary:	libpng - DLL library for Windows
Summary(pl.UTF-8):	libpng - biblioteka DLL dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-zlib-dll >= 1.2.9
Requires:	wine
Provides:	crossmingw32-libpng-dll(APNG) = 0.10

%description dll
libpng - DLL library for Windows.

%description dll -l pl.UTF-8
libpng - biblioteka DLL dla Windows.

%prep
%setup -q -n %{realname}-%{version}
%patch -P0 -p1
%patch -P1 -p1

%build
%configure \
	--target=%{target} \
	--host=%{target} \
	--with-pkgconfigdir=%{_pkgconfigdir}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_dlldir}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/bin/*.dll $RPM_BUILD_ROOT%{_dlldir}

ln -sf libpng16.dll.a $RPM_BUILD_ROOT%{_libdir}/libpng.dll.a

%if 0%{!?debug:1}
%{target}-strip --strip-unneeded -R.comment -R.note $RPM_BUILD_ROOT%{_dlldir}/*.dll
%{target}-strip -g -R.comment -R.note $RPM_BUILD_ROOT%{_libdir}/*.a
%endif

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/man

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_libdir}/libpng16.dll.a
%{_libdir}/libpng.dll.a
%{_libdir}/libpng16.la
%{_libdir}/libpng.la
%{_includedir}/libpng16
%{_includedir}/png*.h
%{_pkgconfigdir}/libpng16.pc
%{_pkgconfigdir}/libpng.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libpng16.a
%{_libdir}/libpng.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libpng16-*.dll
%changelog
* Mon Feb 24 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-libpng.git;a=log;h=master

* Mon Feb 24 2025 Jakub Bogusz <qboosh@pld-linux.org> f135834
- updated to 1.6.46

* Sat Jan 11 2025 Jakub Bogusz <qboosh@pld-linux.org> 34b6cfe
- updated to 1.6.45

* Mon Sep 16 2024 Jakub Bogusz <qboosh@pld-linux.org> 37f3816
- updated to 1.6.44

* Sun Feb 25 2024 Jakub Bogusz <qboosh@pld-linux.org> 01b0092
- updated to 1.6.43

* Sun Sep 10 2023 Jakub Bogusz <qboosh@pld-linux.org> 9c30c21
- updated to 1.6.40

* Wed Nov 30 2022 Jakub Bogusz <qboosh@pld-linux.org> 4c7e6a9
- updated to 1.6.39

* Fri Sep 16 2022 Jakub Bogusz <qboosh@pld-linux.org> cd6c4f2
- updated to 1.6.38

* Tue Apr 23 2019 Jakub Bogusz <qboosh@pld-linux.org> e940033
- updated to 1.6.37

* Fri Dec 07 2018 Jakub Bogusz <qboosh@pld-linux.org> f8c2974
- updated to 1.6.36

* Sat Jul 21 2018 Jakub Bogusz <qboosh@pld-linux.org> ea3dd92
- updated to 1.6.35

* Tue Nov 14 2017 Jakub Bogusz <qboosh@pld-linux.org> 93eba9d
- updated to 1.6.34

* Sun Jul 30 2017 Jakub Bogusz <qboosh@pld-linux.org> fac68b1
- updated to 1.6.31

* Mon Apr 03 2017 Jakub Bogusz <qboosh@pld-linux.org> 9e5b84f
- updated to 1.6.29

* Fri Feb 03 2017 Jakub Bogusz <qboosh@pld-linux.org> 3db476b
- updated to 1.6.28 (fixes CVE-2016-10087)
- when compiled with zlib >= 1.2.9, requires zlib 1.2.9

* Sun Dec 04 2016 Jakub Bogusz <qboosh@pld-linux.org> ec4740e
- updated to 1.6.26

* Fri Oct 07 2016 Jakub Bogusz <qboosh@pld-linux.org> 503cab8
- updated to 1.6.25

* Sun Aug 28 2016 Jakub Bogusz <qboosh@pld-linux.org> d8f8996
- updated to 1.6.24

* Thu Jun 09 2016 Jakub Bogusz <qboosh@pld-linux.org> bc92ceb
- updated to 1.6.23

* Sun Jan 24 2016 Jakub Bogusz <qboosh@pld-linux.org> ecef608
- updated to 1.6.21

* Sat Dec 05 2015 Jakub Bogusz <qboosh@pld-linux.org> 9bf6f36
- updated to 1.6.20 (fixes CVE-2015-8126)

